#pragma once
#include "Command.h"
#include "CommandReply.h"
using namespace scene;
class CmdProcessor
{
	
public:
	static Device* dev;	
	static CommandReply* processCommand(Command* cmd,bool inMain);
private: 
		
	enum CmdType
	{
		cam_setTarget,
		ccl_setVisible,
		dev_closeDevice,
		dev_setWindowCaption,
		dev_getVideoModeList,
		dev_getVideoDriver,
		drv_addDynamicLight,
		drv_addExternalImageLoader,
		drv_addExternalImageWriter,
		drv_addMaterialRenderer,
		drv_addTexture,
		drv_clearZBuffer,
		drv_createAttributesFromMaterial,
		drv_createImageFromData,
		drv_createImageFromFile,
		drv_createRenderTargetTexture,
		drv_createScreenShot,
		drv_deleteAllDynamicLights,
		drv_draw2DImage,
		drv_draw2DLine,
		drv_draw2DPolygon,
		drv_draw2DRectangle,
		drv_draw3DBox,
		drv_draw3DLine,
		drv_draw3DTriangle,
		drv_drawIndexedTriangleFan,
		drv_drawIndexedTriangleList,
		drv_drawMeshBuffer,
		drv_drawStencilShadow,
		drv_drawStencilShadowVolume,
		drv_drawVertexPrimitiveList,
		drv_fillMaterialStructureFromAttributes,
		drv_getCurrentRenderTargetSize,
		drv_getDriverType,
		drv_getDynamicLight,
		drv_getDynamicLightCount,
		drv_getFPS,
		drv_getGPUProgrammingServices,
		drv_getMaterialRenderer,
		drv_getMaterialRendererCount,
		drv_getMaterialRendererName,
		drv_getMaximalDynamicLightAmount,
		drv_getMaximalPrimitiveCount,
		drv_getName,
		drv_getPrimitiveCountDrawn,
		drv_getScreenSize,
		drv_getTexture,
		drv_getTextureByIndex,
		drv_getTextureCount,
		drv_getTextureCreationFlag,
		drv_getTransform,
		drv_getViewPort,
		drv_makeColorKeyTexture,
		drv_makeNormalMapTexture ,
		drv_queryFeature,
		drv_removeAllTextures,
		drv_removeTexture,
		drv_renameTexture,
		drv_setAmbientLight,
		drv_setFog,
		drv_setMaterial,
		drv_setMaterialRendererName,
		drv_setRenderTarget,
		drv_setTextureCreationFlag,
		drv_setTransform,
		drv_setViewPort,
		drv_writeImageToFile,
		fst_addZipFileArchive,
		gui_addStaticText,
		nod_addAnimator,
		nod_setAnimationSpeed,
		nod_setFrameLoop,
		nod_setMaterialFlag,		
		nod_setMaterialTexture,
		nod_setMD2Animation,
		nod_setPosition,
		nod_setRotation,
		nod_setScale,
		smr_addAnimatedMeshSceneNode,
		smr_addArrowMesh,
		smr_addBillboardSceneNode,
		smr_addBillboardTextSceneNode,
		smr_addCameraSceneNode,
		smr_addCameraSceneNodeFPS,
		smr_addCameraSceneNodeMaya,
		smr_addCubeSceneNode,
		smr_addDummyTransformationSceneNode,
		smr_addEmptySceneNode,
		smr_addExternalMeshLoader,
		smr_addHillPlaneMesh,
		smr_addLightSceneNode,
		smr_addMeshSceneNode,
		smr_addOctTreeSceneNode,
		smr_addParticleSystemSceneNode,
		smr_addQuake3SceneNode,
		smr_addSceneNode,
		smr_addSkyBoxSceneNode,
		smr_addSkyDomeSceneNode,
		smr_addSphereSceneNode,
		smr_addTerrainMesh,
		smr_addTerrainSceneNode,
		smr_addTextSceneNode,
		smr_addToDeletionQueue,
		smr_addWaterSurfaceSceneNode,
		smr_createCollisionResponseAnimator,
		smr_createDeleteAnimator,
		smr_createFlyCircleAnimator,
		smr_createFlyStraightAnimator,
		smr_createFollowSplineAnimator,
		smr_createMetaTriangleSelector,
		smr_createOctTreeTriangleSelector,
		smr_createRotationAnimator,
		smr_createTerrainTriangleSelector,
		smr_createTextureAnimator,
		smr_createTriangleSelector,
		smr_createTriangleSelectorFromBoundingBox,
		smr_createSpecialAnimator,
		smr_getActiveCamera,
		smr_getAmbientLight,
		smr_getDefaultSceneNodeAnimatorFactory,
		smr_getDefaultSceneNodeFactory,
		smr_getGUIEnvironment,
		smr_getMesh,
		smr_getMeshCache,
		smr_getMeshManipulator,
		smr_getParameters,
		smr_getRegisteredSceneNodeAnimatorFactoryCount,
		smr_getRegisteredSceneNodeFactoryCount,
		smr_getRootSceneNode,
		smr_getSceneCollisionManager,
		smr_getSceneNodeAnimatorFactory,
		smr_getSceneNodeFactory,
		smr_getSceneNodeFromId,
		smr_getSceneNodeFromName,
		smr_getSceneNodeFromType,
		smr_getSceneNodeRenderPass,
		smr_getSceneNodesFromType,
		smr_getSceneNodeTypeName,
		smr_getShadowColor,
		smr_getVideoDriver,
		smr_loadScene,
		smr_registerSceneNodeAnimatorFactory ,
		smr_registerSceneNodeFactory,
		smr_saveScene,
		smr_setActiveCamera,
		smr_setAmbientLight,
		smr_setShadowColor,


		unknwn
	};
	static CmdType c(stringw CmdName);
};
